searchNodes=[{"doc":"Ecto.DateTimeRange provides modules implementing Ecto.Type to allow usage of Postgres range times encoding timestamp ranges.","ref":"Ecto.DateTimeRange.html","title":"Ecto.DateTimeRange","type":"module"},{"doc":"Create an Ecto.UTCDateTimeRange from two ISO8601 strings. Example iex&gt; import Ecto.DateTimeRange , only : [ sigil_t : 2 ] ...&gt; iex&gt; ~t(2020-02-02T00:01:00Z..2020-02-02T00:01:01Z) % Ecto.UTCDateTimeRange { start_at : ~U[2020-02-02T00:01:00Z] , end_at : ~U[2020-02-02T00:01:01Z] } ...&gt; iex&gt; ~t(hi there) ** (ArgumentError) Unable to parse DateTime(s) from input ...&gt; iex&gt; ~t(00:01:00Z..00:01:01Z)T % Ecto.UTCTimeRange { start_at : ~T[00:01:00Z] , end_at : ~T[00:01:01Z] }","ref":"Ecto.DateTimeRange.html#sigil_t/2","title":"Ecto.DateTimeRange.sigil_t/2","type":"function"},{"doc":"Provides operators for querying against ranges in PostgreSQL. Usage import Ecto.Query import Ecto.DateTimeRange.Operators now = DateTime . utc_now ( ) from ( thing in Thing , where : contains ( thing . during , ^ now ) )","ref":"Ecto.DateTimeRange.Operators.html","title":"Ecto.DateTimeRange.Operators","type":"module"},{"doc":"","ref":"Ecto.DateTimeRange.Operators.html#contains/2","title":"Ecto.DateTimeRange.Operators.contains/2","type":"macro"},{"doc":"An Ecto.Type wrapping a :tstzrange Postgres column. To the application, it appears as a struct with :start_at and :end_at , with :utc_datetime values. defmodule Core.Thing do use Ecto.Schema import Ecto.Changeset schema &quot;things&quot; do field :performed_during , Ecto.UTCDateTimeRange end @required_attrs ~w[performed_during]a def changeset ( data \\ % __MODULE__ { } , attrs ) do data |&gt; cast ( attrs , @required_attrs ) |&gt; validate_required ( @required_attrs ) end end","ref":"Ecto.UTCDateTimeRange.html","title":"Ecto.UTCDateTimeRange","type":"module"},{"doc":"Converts user-provided data (for example from a form) to the Elixir term.","ref":"Ecto.UTCDateTimeRange.html#cast/1","title":"Ecto.UTCDateTimeRange.cast/1","type":"function"},{"doc":"Returns true or false depending on whether the time is falls within the specified range. Example iex&gt; import Ecto.DateTimeRange ...&gt; iex&gt; Ecto.UTCDateTimeRange . contains? ( ~t[2020-01-01T01:00:00Z..2020-01-02T01:00:00Z]U , ~U[2020-01-01T00:59:59Z] ) false iex&gt; Ecto.UTCDateTimeRange . contains? ( ~t[2020-01-01T01:00:00Z..2020-01-02T01:00:00Z]U , ~U[2020-01-01T01:00:00Z] ) true iex&gt; Ecto.UTCDateTimeRange . contains? ( ~t[2020-01-01T01:00:00Z..2020-01-02T01:00:00Z]U , ~U[2020-01-02T00:59:59Z] ) true iex&gt; Ecto.UTCDateTimeRange . contains? ( ~t[2020-01-01T01:00:00Z..2020-01-02T01:00:00Z]U , ~U[2020-01-02T01:00:00Z] ) false iex&gt; Ecto.UTCDateTimeRange . contains? ( ~t[2020-01-01T01:00:00Z..2020-01-02T01:00:00Z]U , ~U[2020-01-03T01:00:00Z] ) false","ref":"Ecto.UTCDateTimeRange.html#contains?/2","title":"Ecto.UTCDateTimeRange.contains?/2","type":"function"},{"doc":"Converts the Elixir term to the Ecto native type.","ref":"Ecto.UTCDateTimeRange.html#dump/1","title":"Ecto.UTCDateTimeRange.dump/1","type":"function"},{"doc":"Declares than when used in embedded schemas, the type will be dumped before being encoded.","ref":"Ecto.UTCDateTimeRange.html#embed_as/1","title":"Ecto.UTCDateTimeRange.embed_as/1","type":"function"},{"doc":"Checks if two terms are equal.","ref":"Ecto.UTCDateTimeRange.html#equal?/2","title":"Ecto.UTCDateTimeRange.equal?/2","type":"function"},{"doc":"Converts the Ecto native type to the Elixir term.","ref":"Ecto.UTCDateTimeRange.html#load/1","title":"Ecto.UTCDateTimeRange.load/1","type":"function"},{"doc":"Create an Ecto.UTCDateTimeRange from two ISO8601 strings. Example iex&gt; Ecto.UTCDateTimeRange . parse ( &quot;2020-02-02T00:01:00Z..2020-02-02T00:01:01Z&quot; ) { :ok , % Ecto.UTCDateTimeRange { start_at : ~U[2020-02-02T00:01:00Z] , end_at : ~U[2020-02-02T00:01:01Z] } } iex&gt; Ecto.UTCDateTimeRange . parse ( &quot;2020-02-02T00:01:00Z..later&quot; ) { :error , &quot;Unable to parse DateTime(s) from input&quot; }","ref":"Ecto.UTCDateTimeRange.html#parse/1","title":"Ecto.UTCDateTimeRange.parse/1","type":"function"},{"doc":"Declares the native type that will be used in the database.","ref":"Ecto.UTCDateTimeRange.html#type/0","title":"Ecto.UTCDateTimeRange.type/0","type":"function"},{"doc":"","ref":"Ecto.UTCDateTimeRange.html#t:t/0","title":"Ecto.UTCDateTimeRange.t/0","type":"type"},{"doc":"An Ecto.Type wrapping a :tstzrange Postgres column. To the application, it appears as a struct with :start_at and :end_at , with :time values. defmodule Core.Thing do use Ecto.Schema import Ecto.Changeset schema &quot;things&quot; do field :performed_during , Ecto.UTCTimeRange end @required_attrs ~w[performed_during]a def changeset ( data \\ % __MODULE__ { } , attrs ) do data |&gt; cast ( attrs , @required_attrs ) |&gt; validate_required ( @required_attrs ) end end","ref":"Ecto.UTCTimeRange.html","title":"Ecto.UTCTimeRange","type":"module"},{"doc":"Converts user-provided data (for example from a form) to the Elixir term.","ref":"Ecto.UTCTimeRange.html#cast/1","title":"Ecto.UTCTimeRange.cast/1","type":"function"},{"doc":"Returns true or false depending on whether the time is falls within the specified range. Example iex&gt; import Ecto.DateTimeRange ...&gt; iex&gt; Ecto.UTCTimeRange . contains? ( ~t[01:00:00..02:00:00]T , ~T[00:00:00] ) false iex&gt; Ecto.UTCTimeRange . contains? ( ~t[01:00:00..02:00:00]T , ~T[01:00:00] ) true iex&gt; Ecto.UTCTimeRange . contains? ( ~t[01:00:00..02:00:00]T , ~T[01:59:59] ) true iex&gt; Ecto.UTCTimeRange . contains? ( ~t[01:00:00..02:00:00]T , ~T[02:00:00] ) false","ref":"Ecto.UTCTimeRange.html#contains?/2","title":"Ecto.UTCTimeRange.contains?/2","type":"function"},{"doc":"Converts the Elixir term to the Ecto native type.","ref":"Ecto.UTCTimeRange.html#dump/1","title":"Ecto.UTCTimeRange.dump/1","type":"function"},{"doc":"Declares than when used in embedded schemas, the type will be dumped before being encoded.","ref":"Ecto.UTCTimeRange.html#embed_as/1","title":"Ecto.UTCTimeRange.embed_as/1","type":"function"},{"doc":"Checks if two terms are equal.","ref":"Ecto.UTCTimeRange.html#equal?/2","title":"Ecto.UTCTimeRange.equal?/2","type":"function"},{"doc":"Converts the Ecto native type to the Elixir term.","ref":"Ecto.UTCTimeRange.html#load/1","title":"Ecto.UTCTimeRange.load/1","type":"function"},{"doc":"Create an Ecto.UTCDateTimeRange from two ISO8601 strings. Example iex&gt; Ecto.UTCTimeRange . parse ( &quot;00:01:00Z..00:01:01Z&quot; ) { :ok , % Ecto.UTCTimeRange { start_at : ~T[00:01:00Z] , end_at : ~T[00:01:01Z] } } iex&gt; Ecto.UTCTimeRange . parse ( &quot;00:01:00Z..later&quot; ) { :error , &quot;Unable to parse Time(s) from input&quot; }","ref":"Ecto.UTCTimeRange.html#parse/1","title":"Ecto.UTCTimeRange.parse/1","type":"function"},{"doc":"Declares the native type that will be used in the database.","ref":"Ecto.UTCTimeRange.html#type/0","title":"Ecto.UTCTimeRange.type/0","type":"function"},{"doc":"","ref":"Ecto.UTCTimeRange.html#t:t/0","title":"Ecto.UTCTimeRange.t/0","type":"type"},{"doc":"Ecto DateTimeRange is a library extending Ecto with field types to handle PostgreSQL column types encapsulating timestamp ranges. The types provided by this library can be paired with view components in order to facilitate editing ranges in forms.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Add the hex package to mix.exs : def deps do [ { :ecto_date_time_range , &quot;~&gt; 0.1&quot; } ] end If DateTime s will be shifted between time zones at any point during the value's lifecycle, for instance to show/edit timestamps in the time zone reported by a person's browser, then a time zone database must also be added and configured as Elixir's :time_zone_database . https://github.com/mathieuprog/tz https://github.com/lau/tzdata","ref":"overview.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Add migrations using :tstzrange column types. defmodule Core.Repo.Migrations.AddThings do use Ecto.Migration def change do create table ( :things ) do add :performed_during , :tstzrange end end end For more detailed information see the migrations guide .","ref":"overview.html#migrations","title":"Overview - Migrations","type":"extras"},{"doc":"defmodule Core.Thing do use Ecto.Schema import Ecto.Changeset schema &quot;things&quot; do field :performed_during , Ecto.UTCDateTimeRange end @required_attrs ~w[performed_during]a def changeset ( data \\\\ % __MODULE__ { } , attrs ) do data |&gt; cast ( attrs , @required_attrs ) |&gt; validate_required ( @required_attrs ) end end","ref":"overview.html#schemas","title":"Overview - Schemas","type":"extras"},{"doc":"DateTime ranges can be indicated in migrations with the :tstzrange column type. defmodule Core.Repo.Migrations.AddThings do use Ecto.Migration def change do create table ( :things ) do add :profile_id , references ( :profiles ) , null : false add :performed_during , :tstzrange end end end GIST or SP-GIST indexes and constraints can include range operators: defmodule Core.Repo.Migrations.ExcludeOverlappingThings do use Ecto.Migration def change do create constraint ( :things , :no_overlapping_things , exclude : ~s|gist (profile_id with =, performed_during with &amp;&amp;)| ) end end","ref":"migrations.html","title":"Migrations","type":"extras"},{"doc":"Types provided by this library are intended to be used with nested form data that can be cast to ranges as a single unit. For example, a heex component could be written as follows: defmodule Web.Components do use Phoenix.HTML import Phoenix.LiveView.Helpers def utc_date_time_range_field ( assigns ) do ~H&quot;&quot;&quot; &lt;fieldset&gt; &lt;%= error_tag @f, @field %&gt; &lt;input type=&quot;datetime-local&quot; name={&quot;\#{form_name(@f)}[\#{@field}][start_at]&quot;} value={utc_date_time_part(@f, @field, :start_at)} id={&quot;\#{form_name(@f)}_\#{@field}_start_at&quot;} /&gt; &lt;input type=&quot;datetime-local&quot; name={&quot;\#{form_name(@f)}[\#{@field}][end_at]&quot;} value={utc_date_time_part(@f, @field, :end_at)} id={&quot;\#{form_name(@f)}_\#{@field}_end_at&quot;} /&gt; &lt;input type=&quot;hidden&quot; name={&quot;\#{form_name(@f)}[\#{@field}][tz]&quot;} value=&quot;America/Los_Angeles&quot; id={&quot;\#{form_name(@f)}_\#{@field}_tz&quot;} /&gt; &lt;/fieldset&gt; &quot;&quot;&quot; end def utc_time_range_field ( assigns ) do ~H&quot;&quot;&quot; &lt;fieldset id={@field}&gt; &lt;div is=&quot;grouped&quot;&gt; &lt;%= error_tag @f, @field %&gt; &lt;input type=&quot;time&quot; name={&quot;\#{form_name(@f)}[\#{@field}][start_at]&quot;} value={utc_time_part(@f, @field, :start_at)} id={&quot;\#{form_name(@f)}_\#{@field}_start_at&quot;} /&gt; &lt;input type=&quot;time&quot; name={&quot;\#{form_name(@f)}[\#{@field}][end_at]&quot;} value={utc_time_part(@f, @field, :end_at)} id={&quot;\#{form_name(@f)}_\#{@field}_end_at&quot;} /&gt; &lt;input type=&quot;hidden&quot; name={&quot;\#{form_name(@f)}[\#{@field}][tz]&quot;} value=&quot;America/Los_Angeles&quot; id={&quot;\#{form_name(@f)}_\#{@field}_tz&quot;} /&gt; &lt;/div&gt; &lt;/fieldset&gt; &quot;&quot;&quot; end defp form_name ( form ) , do : form . name defp utc_date_time_part ( form , field , part ) do form . source |&gt; Ecto.Changeset . get_field ( field ) |&gt; case do nil -&gt; DateTime . utc_now ( ) % Ecto.UTCDateTimeRange { } = range -&gt; Map . get ( range , part ) |&gt; to_time_zone ( &quot;America/Los_Angeles&quot; ) end end defp utc_time_part ( form , field , part ) do form . source |&gt; Ecto.Changeset . get_field ( field ) |&gt; case do nil -&gt; default_time ( part ) % Ecto.UTCTimeRange { } = range -&gt; Map . get ( range , part ) |&gt; to_time_zone ( &quot;America/Los_Angeles&quot; ) end |&gt; to_time_value ( ) end defp default_time ( :start_at ) , do : ~T[06:00:00] defp default_time ( :end_at ) , do : ~T[18:00:00] defp to_time_value ( % Time { } = time ) , do : Calendar . strftime ( time , &quot;%H:%M&quot; ) defp to_time_zone ( % Time { } = time , tz ) , do : Time . add ( time , tz_offset ( tz ) , :second ) defp to_time_zone ( % DateTime { } = time , tz ) , do : DateTime . add ( time , tz_offset ( tz ) , :second ) defp tz_offset ( tz ) do { :ok , %{ std_offset : _ , utc_offset : offset , zone_abbr : _ } } = Calendar . get_time_zone_database ( ) . time_zone_periods_from_wall_datetime ( NaiveDateTime . utc_now ( ) , tz ) offset end end Components such as this can be used in a parent live view: defmodule Web.MyLiveView do use Web , :live_view import Web.Components @impl Phoenix.LiveView def render ( assigns ) do ~H&quot;&quot;&quot; &lt;.form let={f} for={@changeset} id=&quot;thing-form&quot; phx-change=&quot;validate&quot;&gt; &lt;.utc_date_time_range_field id=&quot;performed-during&quot; f={f} field={:performed_during} /&gt; &lt;%= submit(&quot;Save&quot;) %&gt; &lt;/.form&gt; &quot;&quot;&quot; end @impl Phoenix.LiveView def mount ( _params , _session , socket ) do socket = socket |&gt; assign ( :changeset , Core.Thing . changeset ( %{ } ) ) { :ok , socket } end @impl Phoenix.LiveView def handle_event ( &quot;validate&quot; , %{ &quot;thing&quot; =&gt; params } , socket ) do socket = socket |&gt; assign ( changeset : Core.Things . changeset ( params ) ) { :noreply , socket } end end When this form is sent to the server via POST or in a LiveView's phx-change or phx-submit , the params will arrive in the following format, which matches that expected by Ecto.UTCDateTimeRange.cast/1 : %{ &quot;thing&quot; =&gt; %{ &quot;performed_during&quot; =&gt; %{ &quot;start_at&quot; =&gt; &quot;2022-06-22 01:00:00&quot; , &quot;end_at&quot; =&gt; &quot;2022-06-22 01:00:00&quot; , &quot;tz&quot; =&gt; &quot;Etc/UTC&quot; } } }","ref":"forms.html","title":"Form Data","type":"extras"},{"doc":"","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Fix Ecto.UTCTimeRange.contains?/2 to handle ranges crossing day barrier.","ref":"changelog.html#0-3-1","title":"Change Log - 0.3.1","type":"extras"},{"doc":"Add Ecto.UTCDateTimeRange.contains?/2 . Add Ecto.UTCTimeRange.contains?/2 .","ref":"changelog.html#0-3-0","title":"Change Log - 0.3.0","type":"extras"},{"doc":"Move ~t to Ecto.DateTimeRange . Add Ecto.UTCTimeRange type. Add Ecto.RangeOperators.contains/2 macro.","ref":"changelog.html#0-2-0","title":"Change Log - 0.2.0","type":"extras"},{"doc":"Update docs regarding setup, form data. Clarify errors in UTCDateTimeRange's sigil_t and parse .","ref":"changelog.html#0-1-1","title":"Change Log - 0.1.1","type":"extras"},{"doc":"Initial release of Ecto.UTCDateTimeRange .","ref":"changelog.html#0-1-0","title":"Change Log - 0.1.0","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]